function DisplayText(px, py, textsize, caption)
	local ots = text.size(textsize)
	local otc = text.color(cBlack)

	text.draw(px, py, caption, "center", 300)
	screen.update()
	text.size(ots)
	text.color(otc)
end

function LoadImages()
	local i

	imgL = image.load("Left.png")
	imgLP = image.load("LeftPlus.png")
	imgR = image.load("Right.png")
	imgRP = image.load("RightPlus.png")
	imgBG = image.load("wall.png")
	for i = 0, 9 do
		CarNameH = "car0"..i.."h.png"
		imgCarH[i + 1] = image.load(CarNameH)
		CarNameV = "car0"..i.."v.png"
		imgCarV[i + 1] = image.load(CarNameV)
	end
	for i = 1, 5 do
		TruckNameH = "truck0"..i.."h.png"
		imgTruckH[i] = image.load(TruckNameH)
		TruckNameV = "truck0"..i.."v.png"
		imgTruckV[i] = image.load(TruckNameV)
	end
end

function ClearText(xo, yo, xw, yw)
	screen.fillrect(xo, yo, xw, yw, cBG)
end

function cls()
	local OldscreenOri = screen.orientation()

	-- clear the screen
	screen.clear()
	if OldscreenOri == 0 then -- horizontal
		ClearText(0, 0, 400, 240)
	else -- vertical
		ClearText(0, 0, 240, 400)
	end
	screen.update()
end

function IsInRect(x, y, rx, ry, w, h)
	if x >= rx and x <= (rx + w) and y >= ry and y <= (ry + h) then
		return true
	else
		return false
	end
end

function DrawMainMenu()
	cls()
	DisplayText(100, 20, 25, "Traffic Jam")
	DisplayText(100, 50, 12, "by Chee Keong")

	screen.fillrect(FnSelect.x - 46, FnSelect.y, FnSelect.w + 122, FnSelect.h, color.new(180, 180, 180))
	screen.drawrect(FnSelect.x - 1 - 46, FnSelect.y - 1, FnSelect.x + FnSelect.w + 1 + 76, FnSelect.y + FnSelect.h + 1, color.new(255, 255, 255))
	DisplayText(105, FnSelect.y + 3, 15, FnSelect.name..GameN)

	imgR:draw(FnSelect.x + FnSelect.w + 30, FnSelect.y)
	imgRP:draw(FnSelect.x + FnSelect.w + 52, FnSelect.y)

	imgL:draw(FnSelect.x - 22, FnSelect.y)
	imgLP:draw(FnSelect.x - 44, FnSelect.y)

	screen.fillrect(FnLoad.x - 26, FnLoad.y, FnLoad.w + 52, FnLoad.h, color.new(180, 180, 180))
	screen.drawrect(FnLoad.x - 1 - 26, FnLoad.y - 1, FnLoad.x + FnLoad.w + 1 + 26, FnLoad.y + FnLoad.h + 1, color.new(255, 255, 255))
	DisplayText(100, FnLoad.y + 3, 15, FnLoad.name)

	screen.fillrect(FnMainExit.x - 26, FnMainExit.y, FnMainExit.w + 52, FnMainExit.h, color.new(180, 180, 180))
	screen.drawrect(FnMainExit.x - 1 - 26, FnMainExit.y - 1, FnMainExit.x + FnMainExit.w + 1 + 26, FnMainExit.y + FnMainExit.h + 1, color.new(255, 255, 255))
	DisplayText(100, FnMainExit.y + 3, 15, FnMainExit.name)

	DisplayText(100, 210, 12, "Credits to Dr. Mike")
	DisplayText(75, 220, 12, "www.dr-mikes-math-games-for-kids.com")
	screen.update()
end

function DisplayLevel(lvl)
	cls()
	DisplayText(255, 5, 20, "Traffic Jam")
	screen.drawline(255, 25, 362, 25, cWhite, 1)
	DisplayText(255, 30, 15, "Game # ".. GameN)
	if GameHistory[GameN] == -1 then GameHistory[GameN] = 0 end
	DisplayText(255, 50, 15, "Move #")
	DisplayText(255, 70, 15, "[Max - "..GameHistory[GameN].." moves]")
	DisplayText(280, 220, 9, "Credits to Dr. Mike")
	DisplayText(240, 230, 9, "dr-mikes-math-games-for-kids.com")

	screen.fillrect(FnMain.x, FnMain.y, FnMain.w, FnMain.h, color.new(180, 180, 180))
	screen.drawrect(FnMain.x - 1, FnMain.y - 1, FnMain.x + FnMain.w + 1, FnMain.y + FnMain.h + 1, color.new(255, 255, 255))
	DisplayText(290, FnMain.y + 5, 12, FnMain.name)

	screen.fillrect(FnReset.x, FnReset.y, FnReset.w, FnReset.h, color.new(180, 180, 180))
	screen.drawrect(FnReset.x - 1, FnReset.y - 1, FnReset.x + FnReset.w + 1, FnReset.y + FnReset.h + 1, color.new(255, 255, 255))
	DisplayText(300, FnReset.y + 3, 15, FnReset.name)

	screen.update()
end

function DrawCar()
	local i, j

	j = TLevel[GameN].Cars
	for i = 1, TLevel[GameN].Cars do --number of Cars
		if TLevel[GameN][i].Orient == 1 then
			imgCarH[i]:draw(TLevel[GameN][i].xcur, TLevel[GameN][i].ycur)
		else
			imgCarV[i]:draw(TLevel[GameN][i].xcur, TLevel[GameN][i].ycur)
		end
	end
	for i = 1, TLevel[GameN].Trucks do --number of Trucks
		if TLevel[GameN][i + j].Orient == 1 then
			imgTruckH[i]:draw(TLevel[GameN][i + j].xcur, TLevel[GameN][i + j].ycur)
		else
			imgTruckV[i]:draw(TLevel[GameN][i + j].xcur, TLevel[GameN][i + j].ycur)
		end
	end
end

function CleanUp()
	local i

	imgL:close()
	imgL = nil
	imgLP:close()
	imgLP = nil
	imgR:close()
	imgR = nil
	imgRP:close()
	imgRP = nil
	imgBG:close()
	imgBG = nil
	for i = 1, 10 do
		imgCarH[i]:close()
		imgCarH[i] = nil
		imgCarV[i]:close()
		imgCarV[i] = nil
	end
	for i = 1, 5 do
		imgTruckH[i]:close()
		imgTruckH[i] = nil
		imgTruckV[i]:close()
		imgTruckV[i] = nil
	end
end

function CheckTouch(tx, ty)
	local i, Num = 1, 99

	for i = 1, TLevel[GameN].Blocks do
		if IsInRect(tx, ty, TLevel[GameN][i].xcur, TLevel[GameN][i].ycur, TLevel[GameN][i].w, TLevel[GameN][i].h) == true then
			Num = i
		end
	end

	return Num
end


function FixPos(Num, Pxnew, Pynew)
	local x, y

	x = (Pxnew - 24) / 32
	y = (Pynew - 24) / 32

	if Num ~= 99 then
		if x < 1 then
			if (Pxnew - 24) < 16 then
				TLevel[GameN][Num].xcur = 24
			else
				TLevel[GameN][Num].xcur = 56
			end
		elseif x < 2 then
			if (Pxnew - 56) < 16 then
				TLevel[GameN][Num].xcur = 56
			else
				TLevel[GameN][Num].xcur = 88
			end
		elseif x < 3 then
			if (Pxnew - 88) < 16 then
				TLevel[GameN][Num].xcur = 88
			else
				TLevel[GameN][Num].xcur = 120
			end
		elseif x < 4 then
			if (Pxnew - 120) < 16 then
				TLevel[GameN][Num].xcur = 120
			else
				TLevel[GameN][Num].xcur = 152
			end
		end

		if y < 1 then
			if (Pynew - 24) < 16 then
				TLevel[GameN][Num].ycur = 24
			else
				TLevel[GameN][Num].ycur = 56
			end
		elseif y < 2 then
			if (Pynew - 56) < 16 then
				TLevel[GameN][Num].ycur = 56
			else
				TLevel[GameN][Num].ycur = 88
			end
		elseif y < 3 then
			if (Pynew - 88) < 16 then
				TLevel[GameN][Num].ycur = 88
			else
				TLevel[GameN][Num].ycur = 120
			end
		elseif y < 4 then
			if (Pynew - 120) < 16 then
				TLevel[GameN][Num].ycur = 120
			else
				TLevel[GameN][Num].ycur = 152
			end
		end
	end
end

function MoveVehicle(Num, pxo, tx, pyo, ty)
	local Ax, Ay = 0, 0

	if TLevel[GameN][Num].Orient == 1 then
		if (tx - pxo) > 25 then
			Ax = 6
		elseif (pxo - tx) > 25 then
			Ax = -6
		else
			Ax = 0
		end
		Ay = 0
	else
		if (ty - pyo) > 25 then
			Ay = 6
		elseif (pyo - ty) > 25 then
			Ay = -6
		else
			Ay = 0
		end
		Ax = 0
	end

	if Ax == 0 and Ay == 0 then
		ValidMove = false
	else
		ValidMove = true
	end
	TLevel[GameN][Num].xold = TLevel[GameN][Num].xcur
	TLevel[GameN][Num].yold = TLevel[GameN][Num].ycur
	TLevel[GameN][Num].xcur = TLevel[GameN][Num].xcur + Ax
	TLevel[GameN][Num].ycur = TLevel[GameN][Num].ycur + Ay
	if TLevel[GameN][Num].xcur < 24 then TLevel[GameN][Num].xcur = 24 end
	if TLevel[GameN][Num].ycur < 24 then TLevel[GameN][Num].ycur = 24 end

	return TLevel[GameN][Num].xcur, TLevel[GameN][Num].ycur
end

function CheckBound(Num)
	if Num == 1 then
		if TLevel[GameN][Num].xcur + TLevel[GameN][Num].w > 216 then
			cls()
			DisplayText(60, 50, 50, "Well Done!")
			DisplayText(35, 120, 15, "You took "..Move.." moves to complete this game ("..GameN..")")
			DisplayText(60, 150, 15, "Loading next game...")
			SavedGame[GameN] = tostring(GameN)..","..tostring(Move)
			if GameN < #TLevel then
				os.sleep(100)
				cls()
				GameN = GameN + 1
				Move = -1
				ValidMove = false
				DisplayLevel(GameN)
			else
				cls()
				DisplayText(50, 120, 15, "This is all we have.")
				DisplayText(50, 150, 15, "Thank you for playing.")
				os.sleep(200)
				endprogram = true
				GameN = 1
			end
			LastPlayed = GameN
		end
	else
		if TLevel[GameN][Num].xcur + TLevel[GameN][Num].w > 216 then TLevel[GameN][Num].xcur = 216 - TLevel[GameN][Num].w end
		if TLevel[GameN][Num].ycur + TLevel[GameN][Num].h > 216 then TLevel[GameN][Num].ycur = 216 - TLevel[GameN][Num].h end
	end
end

function CheckCollision(Num)
	local i

	for i = 1, TLevel[GameN].Blocks do
		if Num ~= i then
			if TLevel[GameN][Num].Orient == TLevel[GameN][i].Orient then
				if TLevel[GameN][Num].Orient == 1 then -- horizontal
					if TLevel[GameN][Num].ycur == TLevel[GameN][i].ycur then
						if TLevel[GameN][Num].xcur > TLevel[GameN][i].xcur and TLevel[GameN][Num].xcur < TLevel[GameN][i].xcur + TLevel[GameN][i].w then
							TLevel[GameN][Num].xcur = TLevel[GameN][i].xcur + TLevel[GameN][i].w
						elseif TLevel[GameN][Num].xcur + TLevel[GameN][Num].w >= TLevel[GameN][i].xcur and TLevel[GameN][Num].xcur + TLevel[GameN][Num].w < TLevel[GameN][i].xcur + TLevel[GameN][i].w then
							TLevel[GameN][Num].xcur = TLevel[GameN][i].xcur - TLevel[GameN][Num].w
						end
					end
				else
					if TLevel[GameN][Num].xcur == TLevel[GameN][i].xcur then
						if (TLevel[GameN][Num].ycur >= TLevel[GameN][i].ycur and TLevel[GameN][Num].ycur < TLevel[GameN][i].ycur + TLevel[GameN][i].h) then
							TLevel[GameN][Num].ycur = TLevel[GameN][i].ycur + TLevel[GameN][i].h
						elseif (TLevel[GameN][Num].ycur + TLevel[GameN][Num].h >= TLevel[GameN][i].ycur and TLevel[GameN][Num].ycur + TLevel[GameN][Num].h < TLevel[GameN][i].ycur + TLevel[GameN][i].h) then
							TLevel[GameN][Num].ycur = TLevel[GameN][i].ycur - TLevel[GameN][Num].h
						end
					end
				end
			else
				if TLevel[GameN][Num].Orient == 1 then -- horizontal
					if (TLevel[GameN][Num].ycur >= TLevel[GameN][i].ycur and TLevel[GameN][Num].ycur < TLevel[GameN][i].ycur + TLevel[GameN][i].h) then
						if (TLevel[GameN][Num].xcur >= TLevel[GameN][i].xcur and TLevel[GameN][Num].xcur < TLevel[GameN][i].xcur + TLevel[GameN][i].w) then
							TLevel[GameN][Num].xcur = TLevel[GameN][i].xcur + TLevel[GameN][i].w
						elseif TLevel[GameN][Num].xcur + TLevel[GameN][Num].w > TLevel[GameN][i].xcur and TLevel[GameN][Num].xcur + TLevel[GameN][Num].w <= TLevel[GameN][i].xcur + TLevel[GameN][i].w then
							TLevel[GameN][Num].xcur = TLevel[GameN][i].xcur - TLevel[GameN][Num].w
						end
					end
				else
					if (TLevel[GameN][Num].xcur >= TLevel[GameN][i].xcur and TLevel[GameN][Num].xcur < TLevel[GameN][i].xcur + TLevel[GameN][i].w) then
						if (TLevel[GameN][Num].ycur >= TLevel[GameN][i].ycur and TLevel[GameN][Num].ycur < TLevel[GameN][i].ycur + TLevel[GameN][i].h) then
							TLevel[GameN][Num].ycur = TLevel[GameN][i].ycur + TLevel[GameN][i].h
						elseif (TLevel[GameN][Num].ycur + TLevel[GameN][Num].h > TLevel[GameN][i].ycur and TLevel[GameN][Num].ycur + TLevel[GameN][Num].h <= TLevel[GameN][i].ycur + TLevel[GameN][i].h) then
							TLevel[GameN][Num].ycur = TLevel[GameN][i].ycur - TLevel[GameN][Num].h
						end
					end
				end
			end
		end
	end
end

function ExitProgram()
	local OldscreenOri = screen.orientation()
	local OldTextSize = text.size(50)
	local i
	local charE = "\r\n"

	cls()
	file = io.open("Level.txt", "w")
	for i = 1, #TLevel do
		file:write(SavedGame[i]..charE)
	end
	SavedGame[#TLevel + 1] = tostring(GameN)..","..tostring(Move)
	file:write(SavedGame[#TLevel + 1]..charE)
	file:close()
	text.color(cBlack)
	if OldscreenOri == 1 then
		text.draw(10, 150, "Bye bye!")
	else
		text.draw(100, 90, "Bye bye!")
	end
	screen.update()
	text.size(OldTextSize)
	os.sleep(50)
end

function LoadGame()
	local i, j, s, e, line, temp

	for i = 1, #TLevel do
		GameHistory[i] = 0
	end
	file = io.open("Level.txt", "r")
	if file ~= nil then
		j = file:seek("end")
		file:seek("set")
	else
		j = 0
	end
	if file ~= nil and j ~= 0 then
		i = 0
		for line in file:lines() do	-- count the number of lines in the file
			i = i + 1
		end
		j = i
		file:seek("set")
		for i = 1, j - 1 do
			line = file:read("*l")
		end
		s, n = string.find(line, ",") -- compare the highest level created
		temp = tonumber(string.sub(line, 1, s - 1))
		file:seek("set")
		for i = 1, temp do -- read in # moves for all levels
			line = file:read("*l")
			s, n = string.find(line, ",")
			GameHistory[i] = tonumber(string.sub(line, s + 1))
			SavedGame[i] = i..","..string.sub(line, s + 1)
		end
		line = file:read("*l")
		s, n = string.find(line, ",")
		LastPlayed = tonumber(string.sub(line, 1, s - 1))
		if temp < #TLevel then
			for i = temp + 1, #TLevel do
				SavedGame[i] = i..",0"
			end
		end
	else
		for i = 1, #TLevel do SavedGame[i] = i..",0" end
		LastPlayed = 1
	end
	io.close()
end
